<template>
  <v-dialog v-model="dialog" max-width="500">
    <v-card>
      <v-card-title class="headline">Update Group</v-card-title>

      <v-card-text>
        <v-form v-model="valid">
          <v-list>
            <v-text-field label="Name" v-model="name"/>
          </v-list>
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>

        <v-btn color="red darken-1" flat="flat" @click="dialog = false" :loading="loading">Cancel</v-btn>
        <v-btn
          color="green darken-1"
          flat="flat"
          @click="updateGroup(); dialog = false"
          :loading="loading"
        >Agree</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import gql from "graphql-tag";

export default {
  props: {
    id: String
  },
  data() {
    return {
      group: null,
      valid: null,
      dialog: false,
      loading: false,
      updates: {}
    };
  },
  computed: {
    name: {
      get() {
        return this.updates.name || (this.group && this.group.name);
      },
      set(v) {
        this.updates.name = v;
      }
    }
  },
  apollo: {
    group: {
      query: gql`
        query($id: ID!) {
          group: productGroup(id: $id) {
            id
            name
          }
        }
      `,
      skip() {
        return !this.id;
      },
      variables() {
        return { id: this.id };
      }
    }
  },
  methods: {
    open() {
      this.dialog = true;
    },
    async updateGroup() {
      this.loading = true;

      try {
        await this.$apollo.mutate({
          mutation: gql`
            mutation($id: ID!, $group: ProductGroupInputUpdate!) {
              productGroupUpdate(id: $id, group: $group) {
                id
              }
            }
          `,
          variables: {
            id: this.id,
            group: this.updates
          }
        });
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    }
  }
};
</script>
